// apachemod/anyterm.h
// This file is part of Anyterm; see http://anyterm.org/
// (C) 2005-2006 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


// This file defines common data types used for communication between
// the front and back-end processes, and entry points from the web
// server interface.

#ifndef anyterm_h
#define anyterm_h

#include "HttpRequest.hh"

#ifdef __FreeBSD__
#include <machine/param.h>
#include <sys/types.h>
#endif


#include <string>
#include <utility>


// Structure to store the state of an Anyterm session:

struct anyterm_backend;  // private backend state


std::string decode_uri_escapes(std::string s);

void signal_backend(void);



// Entry points from the web server interface:

void setup_backend_shmem(void);

typedef std::pair<std::string,std::string> response_t;

response_t process_request(const HttpRequest& request, std::string command);


// Shared memory stuff:

extern char* shm_name;
extern bool shm_opened;


#endif

