// src/Iconvert.hh
// This file is part of libpbe; see http://decimail.org and http://anyterm.org
// (C) 2006 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// C++ wrapper around iconv.

// This is not thread-safe in the sense that an Iconver object cannot
// be used safely from multiple threads; each thread must have its own
// object.

#ifndef libpbe_Iconver_hh
#define libpbe_Iconver_hh

#include <iconv.h>

#include <string>

class Iconver {

public:
  Iconver(std::string from_charset, std::string to_charset);
  ~Iconver();
  std::string operator()(std::string i);
  std::string operator()(const char* i, size_t l);

private:
  iconv_t iconverter;
};


#endif
